Attribute VB_Name = "vbColDet"
Option Explicit
'-------------------------------------------------------------------------------------------
'Author           : Paul Dahuach
'Year             : 2008
'Legal            : Do whatever you want with it, send me some feedback if you want.
'More Examples    : http://www.pauldahuach.com.ar/program_en.htm
'Dependencies     : coldet.dll (http://www.photoneffect.com/coldet/)
'                 : vbColDet.dll (http://www.pauldahuach.com.ar/program_en.htm)
'-------------------------------------------------------------------------------------------

' Collision Model.  Will represent the mesh to be tested for
' collisions.  It has to be notified of all triangles, via
' addTriangle()
' After all triangles are added, a call to finalize() will
' process the information and prepare for collision tests.
' Call collision() to check for a collision
'
' Note: Transformations must not contain scaling.

' Use to enter the coordinates of the model's triangles.
Public Declare Sub modelA_addTriangle Lib "vbColDet.dll" Alias "vb6_modelA_addTriangle" (ByVal x1 As Single, ByVal y1 As Single, ByVal z1 As Single, ByVal x2 As Single, ByVal y2 As Single, ByVal z2 As Single, ByVal x3 As Single, ByVal y3 As Single, ByVal z3 As Single)

' All triangles have been added, process model.
Public Declare Sub modelA_finalize Lib "vbColDet" Alias "vb6_modelA_finalize" ()

' The the current affine matrix for the model.
' See transform.txt for format information
Public Declare Sub modelA_setTransform Lib "vbColDet" Alias "vb6_modelA_setTransform" (m As Single)

' Check for collision with modelB.
Public Declare Function modelA_collision Lib "vbColDet" Alias "vb6_modelA_collision" () As Boolean

' Optional: Optimization for construction speed.
' If you know the number of triangles.
Public Declare Sub modelA_setTriangleNumber Lib "vbColDet" Alias "vb6_modelA_setTriangleNumber" (ByVal num As Long)

' Returns true if the ray given in world space coordinates
' intersects with the object.
' getCollidingTriangles() and getCollisionPoint() can be
' used to retrieve information about a collision.
' If closest if false, the first triangle that collides with
' the ray is used.  Otherwise the closest one will be used.
' Closest triangle searching will slow the test considerably.
' The default ray is a standard infinite ray.  However, using
' segmin and segmax you can define a line segment along the ray.
Public Declare Function modelA_rayCollision Lib "vbColDet" Alias "vb6_modelA_rayCollision" (origin As Single, direction As Single, ByVal closest As Long, ByVal segmin As Single, ByVal segmax As Single) As Long

' Returns true if the given sphere collides with the model.
' getCollidingTriangles() and getCollisionPoint() can be
' used to retrieve information about a collision.
Public Declare Function modelA_sphereCollision Lib "vbColDet" Alias "vb6_modelA_sphereCollision" (origin As Single, ByVal radius As Single) As Long

' Retrieve the pair of triangles that collided.
' Only valid after a call to collision() that returned true.
' t1 is this model's triangle and t2 is the other one.
' In case of ray or sphere collision, only t1 will be valid.
' The coordinates will be in _this_ model's coordinate space,
' unless ModelSpace is false, in which case, coordinates will
' be transformed by the model's current transform to world space.
Public Declare Function modelA_getCollidingTriangles Lib "vbColDet" Alias "vb6_modelA_getCollidingTriangles" (t1 As Single, t2 As Single, ByVal ModelSpace As Long) As Long

' Retrieve the pair of triangles indices that collided.
' Only valid after a call to collision() that returned true.
' t1 belongs to _this_ model, while t2 is in the other one.
Public Declare Function modelA_getCollidingTriangleIndexes Lib "vbColDet" Alias "vb6_modelA_getCollidingTriangleIndexes" (t1 As Long, t2 As Long) As Long

' Retrieve the detected collision point.
' Only valid after a call to collision()
' that returned true.
' The coordinates will be in _this_ model's coordinate space,
' unless ModelSpace is false, in which case, coordinates will
' be transformed by the model's current transform to world space.
Public Declare Function modelA_getCollisionPoint Lib "vbColDet" Alias "vb6_modelA_getCollisionPoint" (p As Single, ByVal ModelSpace As Long) As Long

' Free A model's memory, you can only reuse modelA if you call modelA_create()
Public Declare Sub modelA_delete Lib "vbColDet" Alias "vb6_modelA_delete" ()

' If you want to reuse model A, first delete, then create.
Public Declare Sub modelA_create Lib "vbColDet" Alias "vb6_modelA_create" ()

Public Declare Sub modelB_addTriangle Lib "vbColDet.dll" Alias "vb6_modelB_addTriangle" (ByVal x1 As Single, ByVal y1 As Single, ByVal z1 As Single, ByVal x2 As Single, ByVal y2 As Single, ByVal z2 As Single, ByVal x3 As Single, ByVal y3 As Single, ByVal z3 As Single)
Public Declare Sub modelB_finalize Lib "vbColDet" Alias "vb6_modelB_finalize" ()
Public Declare Sub modelB_setTransform Lib "vbColDet" Alias "vb6_modelB_setTransform" (m As Single)
Public Declare Function modelB_collision Lib "vbColDet" Alias "vb6_modelB_collision" () As Boolean
Public Declare Sub modelB_setTriangleNumber Lib "vbColDet" Alias "vb6_modelB_setTriangleNumber" (ByVal num As Long)
Public Declare Function modelB_rayCollision Lib "vbColDet" Alias "vb6_modelB_rayCollision" (origin As Single, direction As Single, ByVal closest As Long, ByVal segmin As Single, ByVal segmax As Single) As Long
Public Declare Function modelB_sphereCollision Lib "vbColDet" Alias "vb6_modelB_sphereCollision" (origin As Single, ByVal radius As Single) As Long
Public Declare Function modelB_getCollidingTriangles Lib "vbColDet" Alias "vb6_modelB_getCollidingTriangles" (t1 As Single, t2 As Single, ByVal ModelSpace As Long) As Long
Public Declare Function modelB_getCollidingTriangleIndexes Lib "vbColDet" Alias "vb6_modelB_getCollidingTriangleIndexes" (t1 As Long, t2 As Long) As Long
Public Declare Function modelB_getCollisionPoint Lib "vbColDet" Alias "vb6_modelB_getCollisionPoint" (p As Single, ByVal ModelSpace As Long) As Long
Public Declare Sub modelB_delete Lib "vbColDet" Alias "vb6_modelB_delete" ()
Public Declare Sub modelB_create Lib "vbColDet" Alias "vb6_modelB_create" ()

